Index: /main/trunk/gli/src/org/greenstone/gatherer/Gatherer.java
===================================================================
--- /main/trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 24231)
+++ /main/trunk/gli/src/org/greenstone/gatherer/Gatherer.java	(revision 24232)
@@ -951,608 +955,640 @@
 			container.setCursor(originalCursor);
 		}
-    }
-
-
-    static public void refresh(int refresh_reason)
-    {
-	if (g_man != null) {
-
-	    g_man.refresh(refresh_reason, c_man.ready());
-	}
-
-	// Now is a good time to force a garbage collect
-	System.gc();
-    }
-
-
-    // used to send reload coll messages to the tomcat server
-    static public void configGS3Server(String site, String command) {
-	if (Configuration.library_url == null){
-	    System.out.println("Error: you have not provided the Greenstone Library address.");  
-           return;
-
-	} 
-          
-	try {
-	    // need to add the servlet name to the exec address
-	    String raw_url = Configuration.library_url.toString() + Configuration.getServletPath() + command;
-	    URL url = new URL(raw_url);
-	    DebugStream.println("Action: " + raw_url);
-	    HttpURLConnection library_connection = (HttpURLConnection) url.openConnection();
-	    int response_code = library_connection.getResponseCode();
-	    if(HttpURLConnection.HTTP_OK <= response_code && response_code < HttpURLConnection.HTTP_MULT_CHOICE) {
-		DebugStream.println("200 - Complete.");
-	    }
-	    else {
-		DebugStream.println("404 - Failed.");
-	    }
-	    url = null;
-	}
-	catch(java.net.ConnectException connectException) {
-	    JOptionPane.showMessageDialog(g_man, Dictionary.get("Preferences.Connection.Library_Path_Connection_Failure", Configuration.library_url.toString()), Dictionary.get("General.Warning"), JOptionPane.WARNING_MESSAGE);
-	    DebugStream.println(connectException.getMessage());
-	}
-	catch (Exception exception) {            
-	    DebugStream.printStackTrace(exception);
-	}
-    }
-
-
-    /** Used to 'spawn' a new child application when a file is double clicked.
-     * @param file The file to open 
-     * @see org.greenstone.gatherer.Gatherer.ExternalApplication
-     */
-    static public void spawnApplication(File file) {
-	String [] commands = assoc_man.getCommand(file);
-	if(commands != null) {
-	    ExternalApplication app = new ExternalApplication(commands);
-	    apps.add(app);
-	    app.start();
-	}
-	else {
-	    ///ystem.err.println("No open command available.");
-	}
-    }
-
-
-    static public void spawnApplication(String command)
-    {
-	ExternalApplication app = new ExternalApplication(command);
-	apps.add(app);
-	app.start();
-    }
-
-    static public void spawnApplication(String command, String ID)
-    {
-	ExternalApplication app = new ExternalApplication(command, ID);
-	apps.add(app);
-	app.start();
-    }
-
-    static public void spawnApplication(String[] commands, String ID)
-    {
-	ExternalApplication app = new ExternalApplication(commands, ID);
-	apps.add(app);
-	app.start();
-    }
-
-    static public void terminateApplication(String ID) {
-	for(int i = 0; i < apps.size(); i++) {
-	    ExternalApplication app = (ExternalApplication)apps.get(i);
-	    if(app.getID() != null && app.getID().equals(ID)) {
-		app.stopExternalApplication();
-		apps.remove(app);
-	    }
-	}
-    }
-
-
-    /** Used to 'spawn' a new  browser application or reset an existing one when the preview button is clicked 
-     * @param url The url to open the browser at
-     * @see org.greenstone.gatherer.Gatherer.BrowserApplication
-     */    
-    static public void spawnBrowser(String url) {
-	String command = assoc_man.getBrowserCommand(url);
-	if (command != null) {
-	    BrowserApplication app = new BrowserApplication(command, url);
-	    apps.add(app);
-	    app.start();
-	}
-	else {
-	    ///ystem.err.println("No browser command available."); 
-	}
-    }
-
-
-    /** Prints a warning message about a missing library path, which means the final collection cannot be previewed in the Gatherer.
-     */
-    static public void missingEXEC() {
-	WarningDialog dialog;
-	String configPropertyName = "general.library_url"+Configuration.gliPropertyNameSuffix();
-
-	if (GS3) {
-	    // Warning dialog with no cancel button and no "turn off warning" checkbox 
-	    dialog = new WarningDialog("warning.MissingEXEC", Dictionary.get("MissingEXEC_GS3.Title"), Dictionary.get("MissingEXEC_GS3.Message"), configPropertyName, false, false);
-	} else { // local case
-	    dialog = new WarningDialog("warning.MissingEXEC", Dictionary.get("MissingEXEC.Title"), Dictionary.get("MissingEXEC.Message"), configPropertyName, false);
-	}
-
-	JTextField field = new URLField.Text(Configuration.getColor("coloring.editable_foreground", false), Configuration.getColor("coloring.editable_background", false));
-
-	// Set the default library URL to the tomcat server and port number
-	// specified in the build.properties located in the gsdl3_src_path 
-	if (GS3) {
-	    String host = "localhost";
-	    String port = "8080";
-	    
-	    File buildPropsFile = new File(Configuration.gsdl3_src_path + File.separator + "build.properties");
-	    if(buildPropsFile.exists()) {
-		Properties props = new Properties();
-		try{
-		    props.load(new FileInputStream(buildPropsFile));
-		    host = props.getProperty("tomcat.server", host); 
-		    port = props.getProperty("tomcat.port", port);
-		}catch(Exception e){
-		    DebugStream.println("Could not load build.properties file");
-		    System.err.println("Could not load build.properties file");
-		}
-		props = null;
-	    }
-	    String defaultURL = "http://"+host+":"+port+"/"+"greenstone3";
-	    field.setText(defaultURL);
-	    field.selectAll();
-	}
-	dialog.setValueField(field);
-	dialog.display();
-	dialog.dispose();
-	dialog = null;
-
-	String library_url_string = Configuration.getString(configPropertyName, true);
-	if (!library_url_string.equals("")) {
-	    try {
-		// WarningDialog does not allow invalid URLs, so the following is ignored:
-		// make sure the URL the user provided contains the http:// prefix
-		// and then save the corrected URL
-		if(!library_url_string.startsWith("http://") 
-		   && !library_url_string.startsWith("https://")) {
-		    library_url_string = "http://"+library_url_string;
-		    Configuration.setString(configPropertyName, true, configPropertyName);
-		}
-		Configuration.library_url = new URL(library_url_string);
-	    }
-	    catch (MalformedURLException exception) {
-		DebugStream.printStackTrace(exception);
-	    }
-	}
-    }
-
-
-
-    /** Prints a warning message about a missing library path, which means the final collection cannot be previewed in the Gatherer.
-     */
-    static private void popupFedoraInfo() {
-
-	FedoraLogin dialog = new FedoraLogin("Fedora Login", false);
-
-	if (Configuration.library_url == null) {
-	    
-	    String library_url_string = dialog.getLibraryURL();
-	    if (!library_url_string.equals("")) {
+	}
+
+
+	static public void refresh(int refresh_reason)
+	{
+		if (g_man != null) {
+
+			g_man.refresh(refresh_reason, c_man.ready());
+		}
+
+		// Now is a good time to force a garbage collect
+		System.gc();
+	}
+
+
+	// used to send reload coll messages to the tomcat server
+	static public void configGS3Server(String site, String command) {
+		if (Configuration.library_url == null){
+			System.out.println("Error: you have not provided the Greenstone Library address.");  
+			return;
+
+		} 
+		
 		try {
-		    Configuration.library_url = new URL(library_url_string);
-		}
-		catch (MalformedURLException exception) {
-		    DebugStream.printStackTrace(exception);
-		}
-	    }
-	}
-	
-	boolean showLogin = true;
-	do {
-	    if(!dialog.loginRequested()) { // user pressed cancel to exit the FedoraLogin dialog
-		System.exit(0);
-	    } else {
-		showLogin = dialog.loginRequested();
-		String hostname = dialog.getHostname();
-		String port     = dialog.getPort();
-		String username = dialog.getUsername();
-		String password = dialog.getPassword();
-		String protocol = dialog.getProtocol();
-	    
-		Configuration.fedora_info.setHostname(hostname);
-		Configuration.fedora_info.setPort(port);
-		Configuration.fedora_info.setUsername(username);
-		Configuration.fedora_info.setPassword(password);
-		Configuration.fedora_info.setProtocol(protocol);
-	    
-		String ping_url_str = protocol + "://" + hostname + ":" + port + "/fedora";
-		String login_str = username + ":" + password;
-		
-		String login_encoding = Base64.encodeBytes(login_str.getBytes());
-				
-		try {
-		    URL ping_url = new URL(ping_url_str);
-		    URLConnection uc = ping_url.openConnection();
-		    uc.setRequestProperty  ("Authorization", "Basic " + login_encoding);
-		    // Attempt to access some content ...
-		    InputStream content = (InputStream)uc.getInputStream();
-		    
-		    // if no exception occurred in the above, we would have come here:
-		    showLogin = false;
-		    dialog.dispose();
-		}
-		catch (Exception exception) {
-		    // TODO: move into dictionary
-		    String[] errorMessage = {"Failed to connect to the Fedora server.", "It might not be running, or",
-					     "incorrect username and/or password."};
-		    dialog.setErrorMessage(errorMessage);
-		    //DebugStream.printStackTrace(exception);
-		    // exception occurred, show the dialog again (do this after printing to
-		    // debugStream, else the above does not get done for some reason).
-		    dialog.setVisible(true);
-		}
-	    } 
-	} while(showLogin);
-
-	dialog = null; // no more need of the dialog
-	
-	// Now we are connected.
-    }
-
-
-
-    static private void requestGLIServerURL()
-    {
-	WarningDialog dialog;
-	String[] defaultURLs = {
-	    "http://localhost:8080/greenstone3/cgi-bin/gliserver.pl", 
-	    "http://localhost:8080/gsdl/cgi-bin/gliserver.pl"
-	};
-
-	// Warning dialog with no cancel button and no "turn off warning" checkbox 
-	// (since user-input of the gliserver script is mandatory)
-	dialog = new WarningDialog("warning.MissingGLIServer", Dictionary.get("MissingGLIServer.Title"), Dictionary.get("MissingGLIServer.Message"), "general.gliserver_url", false, false); 
-
-	dialog.setValueField(new URLField.DropDown(Configuration.getColor("coloring.editable_foreground", false), 
-						   Configuration.getColor("coloring.editable_background", false), 
-						   defaultURLs, "general.gliserver_url", 
-						   "general.open_collection"+Configuration.gliPropertyNameSuffix(), 
-						   "gliserver.pl")); 
-
-	if (Gatherer.default_gliserver_url!=null){
-	    dialog.setValueField(Gatherer.default_gliserver_url.toString());
-	}
-
-	// A WarningDialog cannot always be made to respond (let alone to exit the program) on close. We
-	// handle the response of this particular WarningDialog here: a URL for gliserver.pl is a crucial
-	// piece of user-provided data. Therefore, if no URL was entered for gliserver.pl, it'll exit safely.
-	dialog.addWindowListener(new WindowAdapter() {
-		public void windowClosing(WindowEvent e) {
-		    Gatherer.exit();
-		}
-	    });
-	
-	dialog.display();
-	dialog.dispose();
-	dialog = null;
-
-	
-	String gliserver_url_string = Configuration.getString("general.gliserver_url", true);
-	if (!gliserver_url_string.equals("")) {
-	    try {
-		Configuration.gliserver_url = new URL(gliserver_url_string);
-		Configuration.setString("general.gliserver_url", true, gliserver_url_string);
-	    }
-	    catch (MalformedURLException exception) {
-		DebugStream.printStackTrace(exception);
-	    }
-	}
-    }
-
-
-    /** Prints a warning message about a missing GSDL path, which although not fatal pretty much ensures nothing will work properly in the GLI.
-     */
-    static private void missingGSDL() {
-	WarningDialog dialog = new WarningDialog("warning.MissingGSDL", Dictionary.get("MissingGSDL.Title"), Dictionary.get("MissingGSDL.Message"), null, false);
-	dialog.display();
-	dialog.dispose();
-	dialog = null;
-    }
-
-    /** Prints a warning message about missing a valid ImageMagick path, which although not fatal means building image collections won't work */
-    static private void missingImageMagick() {
-	WarningDialog dialog = new WarningDialog("warning.MissingImageMagick", Dictionary.get("MissingImageMagick.Title"), Dictionary.get("MissingImageMagick.Message"), null, false);
-	dialog.display();
-	dialog.dispose();
-	dialog = null;
-    }
-
-    /** Prints a warning message about missing a valid PERL path, which although not fatal pretty much ensures no collection creation/building will work properly in the GLI. */
-    static private void missingPERL() {
-	WarningDialog dialog = new WarningDialog("warning.MissingPERL", Dictionary.get("MissingPERL.Title"), Dictionary.get("MissingPERL.Message"), null, false);
-	dialog.display();
-	dialog.dispose();
-	dialog = null;
-    }
-
-	/** Prints a warning message about the OS not supporting multiple filename encodings.  */
-    static private void multipleFilenameEncodingsNotSupported() {	
-		WarningDialog dialog = new WarningDialog("warning.NoEncodingSupport", 
-			Dictionary.get("NoEncodingSupport.Title"), 
-			Dictionary.get("NoEncodingSupport.Message"), null, false);
+			// need to add the servlet name to the exec address
+			String raw_url = Configuration.library_url.toString() + Configuration.getServletPath() + command;
+			URL url = new URL(raw_url);
+			DebugStream.println("Action: " + raw_url);
+			HttpURLConnection library_connection = (HttpURLConnection) url.openConnection();
+			int response_code = library_connection.getResponseCode();
+			if(HttpURLConnection.HTTP_OK <= response_code && response_code < HttpURLConnection.HTTP_MULT_CHOICE) {
+				DebugStream.println("200 - Complete.");
+			}
+			else {
+				DebugStream.println("404 - Failed.");
+			}
+			url = null;
+		}
+		catch(java.net.ConnectException connectException) {
+			JOptionPane.showMessageDialog(g_man, Dictionary.get("Preferences.Connection.Library_Path_Connection_Failure", Configuration.library_url.toString()), Dictionary.get("General.Warning"), JOptionPane.WARNING_MESSAGE);
+			DebugStream.println(connectException.getMessage());
+		}
+		catch (Exception exception) {            
+			DebugStream.printStackTrace(exception);
+		}
+	}
+
+
+	/** Used to 'spawn' a new child application when a file is double clicked.
+	* @param file The file to open 
+	* @see org.greenstone.gatherer.Gatherer.ExternalApplication
+	*/
+	static public void spawnApplication(File file) {
+		String [] commands = assoc_man.getCommand(file);
+		if(commands != null) {
+			ExternalApplication app = new ExternalApplication(commands);
+			apps.add(app);
+			app.start();
+		}
+		else {
+			///ystem.err.println("No open command available.");
+		}
+	}
+
+
+	static public void spawnApplication(String command)
+	{
+		ExternalApplication app = new ExternalApplication(command);
+		apps.add(app);
+		app.start();
+	}
+
+	static public void spawnApplication(String command, String ID)
+	{
+		ExternalApplication app = new ExternalApplication(command, ID);
+		apps.add(app);
+		app.start();
+	}
+
+	static public void spawnApplication(String[] commands, String ID)
+	{
+		ExternalApplication app = new ExternalApplication(commands, ID);
+		apps.add(app);
+		app.start();
+	}
+
+	static public void terminateApplication(String ID) {
+		for(int i = 0; i < apps.size(); i++) {
+			ExternalApplication app = (ExternalApplication)apps.get(i);
+			if(app.getID() != null && app.getID().equals(ID)) {
+				app.stopExternalApplication();
+				apps.remove(app);
+			}
+		}
+	}
+
+
+	/** Used to 'spawn' a new  browser application or reset an existing one when the preview button is clicked 
+	* @param url The url to open the browser at
+	* @see org.greenstone.gatherer.Gatherer.BrowserApplication
+	*/    
+	static public void spawnBrowser(String url) {
+		String command = assoc_man.getBrowserCommand(url);
+		if (command != null) {
+			BrowserApplication app = new BrowserApplication(command, url);
+			apps.add(app);
+			app.start();
+		}
+		else {
+			///ystem.err.println("No browser command available."); 
+		}
+	}
+
+
+	/** Prints a warning message about a missing library path, which means the final collection cannot be previewed in the Gatherer.
+	*/
+	static public void missingEXEC() {
+		WarningDialog dialog;
+		String configPropertyName = "general.library_url"+Configuration.gliPropertyNameSuffix();
+
+		if (GS3) {
+			// Warning dialog with no cancel button and no "turn off warning" checkbox 
+			dialog = new WarningDialog("warning.MissingEXEC", Dictionary.get("MissingEXEC_GS3.Title"), Dictionary.get("MissingEXEC_GS3.Message"), configPropertyName, false, false);
+		} else { // local case
+			dialog = new WarningDialog("warning.MissingEXEC", Dictionary.get("MissingEXEC.Title"), Dictionary.get("MissingEXEC.Message"), configPropertyName, false);
+		}
+
+		JTextField field = new URLField.Text(Configuration.getColor("coloring.editable_foreground", false), Configuration.getColor("coloring.editable_background", false));
+
+		// Set the default library URL to the tomcat server and port number
+		// specified in the build.properties located in the gsdl3_src_path 
+		if (GS3) {
+			String host = "localhost";
+			String port = "8080";
+			
+			File buildPropsFile = new File(Configuration.gsdl3_src_path + File.separator + "build.properties");
+			if(buildPropsFile.exists()) {
+				Properties props = new Properties();
+				try{
+					props.load(new FileInputStream(buildPropsFile));
+					host = props.getProperty("tomcat.server", host); 
+					port = props.getProperty("tomcat.port", port);
+				}catch(Exception e){
+					DebugStream.println("Could not load build.properties file");
+					System.err.println("Could not load build.properties file");
+				}
+				props = null;
+			}
+			String defaultURL = "http://"+host+":"+port+"/"+"greenstone3";
+			field.setText(defaultURL);
+			field.selectAll();
+		}
+		dialog.setValueField(field);
 		dialog.display();
 		dialog.dispose();
 		dialog = null;
-    }
-
-    /** Sets up the proxy connection by setting JVM Environment flags and creating a new Authenticator.
-     * @see java.lang.Exception
-     * @see java.lang.System
-     * @see java.net.Authenticator
-     * @see org.greenstone.gatherer.Configuration
-     * @see org.greenstone.gatherer.GAuthenticator
-     */
-    static public void setProxy() {
-	try {// Can throw several exceptions
-	    if(Configuration.get("general.use_proxy", true)) {
-		System.setProperty("http.proxyType", "4");
-		System.setProperty("http.proxyHost", Configuration.getString("general.proxy_host", true));
-		System.setProperty("http.proxyPort", Configuration.getString("general.proxy_port", true));
-		System.setProperty("http.proxySet", "true");
-	    } else {
-		System.setProperty("http.proxyHost", "");
-		System.setProperty("http.proxyPort", "");
-		System.setProperty("http.proxySet", "false");
-	    }
-	} catch (Exception error) {
-	    DebugStream.println("Error in Gatherer.initProxy(): " + error);
-	    DebugStream.printStackTrace(error);
-	}
-    }
-
-    
-    /** This private class contains an instance of an external application running within a JVM shell. It is important that this process sits in its own thread, but its more important that when we exit the Gatherer we don't actually System.exit(0) the Gatherer object until the user has volunteerily ended all of these child processes. Otherwise when we quit the Gatherer any changes the users may have made in external programs will be lost and the child processes are automatically deallocated. */
-    static private class ExternalApplication
+
+		String library_url_string = Configuration.getString(configPropertyName, true);
+		if (!library_url_string.equals("")) {
+			try {
+				// WarningDialog does not allow invalid URLs, so the following is ignored:
+				// make sure the URL the user provided contains the http:// prefix
+				// and then save the corrected URL
+				if(!library_url_string.startsWith("http://") 
+						&& !library_url_string.startsWith("https://")) {
+					library_url_string = "http://"+library_url_string;
+					Configuration.setString(configPropertyName, true, configPropertyName);
+				}
+				Configuration.library_url = new URL(library_url_string);
+			}
+			catch (MalformedURLException exception) {
+				DebugStream.printStackTrace(exception);
+			}
+		}
+	}
+
+
+
+	/** Prints a warning message about a missing library path, which means the final collection cannot be previewed in the Gatherer.
+	*/
+	static private void popupFedoraInfo() {
+
+		FedoraLogin dialog = new FedoraLogin("Fedora Login", false);
+
+		if (Configuration.library_url == null) {
+			
+			String library_url_string = dialog.getLibraryURL();
+			if (!library_url_string.equals("")) {
+				try {
+					Configuration.library_url = new URL(library_url_string);
+				}
+				catch (MalformedURLException exception) {
+					DebugStream.printStackTrace(exception);
+				}
+			}
+		}
+		
+		boolean showLogin = true;
+		do {
+			if(!dialog.loginRequested()) { // user pressed cancel to exit the FedoraLogin dialog
+				System.exit(0);
+			} else {
+				showLogin = dialog.loginRequested();
+				String hostname = dialog.getHostname();
+				String port     = dialog.getPort();
+				String username = dialog.getUsername();
+				String password = dialog.getPassword();
+				String protocol = dialog.getProtocol();
+				
+				Configuration.fedora_info.setHostname(hostname);
+				Configuration.fedora_info.setPort(port);
+				Configuration.fedora_info.setUsername(username);
+				Configuration.fedora_info.setPassword(password);
+				Configuration.fedora_info.setProtocol(protocol);
+				
+				String ping_url_str = protocol + "://" + hostname + ":" + port + "/fedora";
+				String login_str = username + ":" + password;
+				
+				String login_encoding = Base64.encodeBytes(login_str.getBytes());
+				
+				try {
+					URL ping_url = new URL(ping_url_str);
+					URLConnection uc = ping_url.openConnection();
+					uc.setRequestProperty  ("Authorization", "Basic " + login_encoding);
+					// Attempt to access some content ...
+					InputStream content = (InputStream)uc.getInputStream();
+					
+					// if no exception occurred in the above, we would have come here:
+					showLogin = false;
+					dialog.dispose();
+				}
+				catch (Exception exception) {
+					// TODO: move into dictionary
+					String[] errorMessage = {"Failed to connect to the Fedora server.", "It might not be running, or",
+						"incorrect username and/or password."};
+					dialog.setErrorMessage(errorMessage);
+					//DebugStream.printStackTrace(exception);
+					// exception occurred, show the dialog again (do this after printing to
+					// debugStream, else the above does not get done for some reason).
+					dialog.setVisible(true);
+				}
+			} 
+		} while(showLogin);
+
+		dialog = null; // no more need of the dialog
+		
+		// Now we are connected.
+	}
+
+
+
+	static private void requestGLIServerURL()
+	{
+		WarningDialog dialog;
+		String[] defaultURLs = {
+			"http://localhost:8080/greenstone3/cgi-bin/gliserver.pl", 
+			"http://localhost:8080/gsdl/cgi-bin/gliserver.pl"
+		};
+
+		// Warning dialog with no cancel button and no "turn off warning" checkbox 
+		// (since user-input of the gliserver script is mandatory)
+		dialog = new WarningDialog("warning.MissingGLIServer", Dictionary.get("MissingGLIServer.Title"), Dictionary.get("MissingGLIServer.Message"), "general.gliserver_url", false, false); 
+
+		dialog.setValueField(new URLField.DropDown(Configuration.getColor("coloring.editable_foreground", false), 
+		Configuration.getColor("coloring.editable_background", false), 
+		defaultURLs, "general.gliserver_url", 
+		"general.open_collection"+Configuration.gliPropertyNameSuffix(), 
+		"gliserver.pl")); 
+
+		if (Gatherer.default_gliserver_url!=null){
+			dialog.setValueField(Gatherer.default_gliserver_url.toString());
+		}
+
+		// A WarningDialog cannot always be made to respond (let alone to exit the program) on close. We
+		// handle the response of this particular WarningDialog here: a URL for gliserver.pl is a crucial
+		// piece of user-provided data. Therefore, if no URL was entered for gliserver.pl, it'll exit safely.
+		dialog.addWindowListener(new WindowAdapter() {
+			public void windowClosing(WindowEvent e) {
+				Gatherer.exit();
+			}
+		});
+		
+		dialog.display();
+		dialog.dispose();
+		dialog = null;
+
+		
+		String gliserver_url_string = Configuration.getString("general.gliserver_url", true);
+		if (!gliserver_url_string.equals("")) {
+			try {
+				Configuration.gliserver_url = new URL(gliserver_url_string);
+				Configuration.setString("general.gliserver_url", true, gliserver_url_string);
+			}
+			catch (MalformedURLException exception) {
+				DebugStream.printStackTrace(exception);
+			}
+		}
+	}
+
+
+	/** Prints a warning message about a missing GSDL path, which although not fatal pretty much ensures nothing will work properly in the GLI.
+	*/
+	static private void missingGSDL() {
+		WarningDialog dialog = new WarningDialog("warning.MissingGSDL", Dictionary.get("MissingGSDL.Title"), Dictionary.get("MissingGSDL.Message"), null, false);
+		dialog.display();
+		dialog.dispose();
+		dialog = null;
+	}
+
+	/** Prints a warning message about missing a valid ImageMagick path, which although not fatal means building image collections won't work */
+	static private void missingImageMagick() {
+		WarningDialog dialog = new WarningDialog("warning.MissingImageMagick", Dictionary.get("MissingImageMagick.Title"), Dictionary.get("MissingImageMagick.Message"), null, false);
+		dialog.display();
+		dialog.dispose();
+		dialog = null;
+	}
+
+	/** Prints a warning message about missing a valid PERL path, which although not fatal pretty much ensures no collection creation/building will work properly in the GLI. */
+	static private void missingPERL() {
+		WarningDialog dialog = new WarningDialog("warning.MissingPERL", Dictionary.get("MissingPERL.Title"), Dictionary.get("MissingPERL.Message"), null, false);
+		dialog.display();
+		dialog.dispose();
+		dialog = null;
+	}
+
+	/** Prints a warning message about the OS not supporting multiple filename encodings.  */
+	static private void multipleFilenameEncodingsNotSupported() {	
+		WarningDialog dialog = new WarningDialog("warning.NoEncodingSupport", 
+		Dictionary.get("NoEncodingSupport.Title"), 
+		Dictionary.get("NoEncodingSupport.Message"), null, false);
+		dialog.display();
+		dialog.dispose();
+		dialog = null;
+	}
+
+	/** Sets up the proxy connection by setting JVM Environment flags and creating a new Authenticator.
+	* @see java.lang.Exception
+	* @see java.lang.System
+	* @see java.net.Authenticator
+	* @see org.greenstone.gatherer.Configuration
+	* @see org.greenstone.gatherer.GAuthenticator
+	*/
+	static public void setProxy() {
+		try {// Can throw several exceptions
+			if(Configuration.get("general.use_proxy", true)) {
+				System.setProperty("http.proxyType", "4");
+				System.setProperty("http.proxyHost", Configuration.getString("general.proxy_host", true));
+				System.setProperty("http.proxyPort", Configuration.getString("general.proxy_port", true));
+				System.setProperty("http.proxySet", "true");
+			} else {
+				System.setProperty("http.proxyHost", "");
+				System.setProperty("http.proxyPort", "");
+				System.setProperty("http.proxySet", "false");
+			}
+		} catch (Exception error) {
+			DebugStream.println("Error in Gatherer.initProxy(): " + error);
+			DebugStream.printStackTrace(error);
+		}
+	}
+
+	
+	/** This private class contains an instance of an external application running within a JVM shell. It is important that this process sits in its own thread, but its more important that when we exit the Gatherer we don't actually System.exit(0) the Gatherer object until the user has volunteerily ended all of these child processes. Otherwise when we quit the Gatherer any changes the users may have made in external programs will be lost and the child processes are automatically deallocated. */
+	static private class ExternalApplication
 	extends Thread {
-	private Process process = null;
-	/** The initial command string given to this sub-process. */
-	private String command = null;
-	private String[] commands = null;
-
-	private String ID = null;
-
-	/** Constructor.
-	 * @param command The initial command <strong>String</strong>.
-	 */
-	public ExternalApplication(String command) {
-	    this.command = command;
-	}
-
-	public ExternalApplication(String[] commands) {
-	    this.commands = commands;
-	}
-
-	public ExternalApplication(String command, String ID) {
-	    this.command = command;
-	    this.ID = ID;
-	}
-
-	public ExternalApplication(String[] commands, String ID) {
-	    this.commands = commands;
-	    this.ID = ID;
+		private Process process = null;
+		/** The initial command string given to this sub-process. */
+		private String command = null;
+		private String[] commands = null;
+
+		private String ID = null;
+
+		/** Constructor.
+	* @param command The initial command <strong>String</strong>.
+	*/
+		public ExternalApplication(String command) {
+			this.command = command;
+		}
+
+		public ExternalApplication(String[] commands) {
+			this.commands = commands;
+		}
+
+		public ExternalApplication(String command, String ID) {
+			this.command = command;
+			this.ID = ID;
+		}
+
+		public ExternalApplication(String[] commands, String ID) {
+			this.commands = commands;
+			this.ID = ID;
+		}
+		
+		public String getID() { 
+			return ID; 
+		}
+
+		/** We start the child process inside a new thread so it doesn't block the rest of Gatherer.
+	* @see java.lang.Exception
+	* @see java.lang.Process
+	* @see java.lang.Runtime
+	* @see java.lang.System
+	* @see java.util.Vector
+	*/
+		public void run() {
+			// Call an external process using the args.
+			try {
+				if(commands != null) {
+					StringBuffer whole_command = new StringBuffer();
+					for(int i = 0; i < commands.length; i++) {
+						whole_command.append(commands[i]);
+						whole_command.append(" ");
+					}
+					DebugStream.println("Running " + whole_command.toString());
+					Runtime rt = Runtime.getRuntime();
+					process = rt.exec(commands);
+					process.waitFor();
+				}
+				else {
+					DebugStream.println("Running " + command);
+					Runtime rt = Runtime.getRuntime();
+					process = rt.exec(command);
+					process.waitFor();
+				}
+			}
+			catch (Exception exception) {
+				DebugStream.printStackTrace(exception);
+			}
+			// Remove ourself from Gatherer list of threads.
+			apps.remove(this);
+			// Call exit if we were the last outstanding child process thread.
+			if (apps.size() == 0 && exit == true) {
+				// In my opinion (DB) there is no need to exit here,
+				// the 'run' method ending naturally brings this
+				// thread to an end.  In fact it is potentially
+				// dangerous to exit here, as the main thread in the
+				// Gatherer class may be stopped prematurely.  As it so
+				// happens the point at which the ExternalApplication thread
+				// is asked to stop (Back in the main Gatherer thread) is after
+				// various configuration files have been saved.
+				// 
+				// A similar argument holds for BrowserApplication thread below.
+				System.exit(exit_status);
+			}
+		}
+		public void stopExternalApplication() {
+			if(process != null) {
+				process.destroy();
+			}
+		}
+	}
+	/** This private class contains an instance of an external application running within a JVM shell. It is important that this process sits in its own thread, but its more important that when we exit the Gatherer we don't actually System.exit(0) the Gatherer object until the user has volunteerily ended all of these child processes. Otherwise when we quit the Gatherer any changes the users may have made in external programs will be lost and the child processes are automatically deallocated. */
+	static private class BrowserApplication
+	extends Thread {
+		private Process process = null;
+		/** The initial command string given to this sub-process. */
+		private String command = null;
+		private String url = null;
+		private String[] commands = null;
+
+		public BrowserApplication(String command, String url) {
+			StringTokenizer st = new StringTokenizer(command);
+			int num_tokens = st.countTokens();
+			this.commands = new String [num_tokens];
+			int i=0;
+			while (st.hasMoreTokens()) {
+				commands[i] = st.nextToken();
+				i++;
+			}
+			//this.commands = commands;
+			this.url = url;
+		}
+		/** We start the child process inside a new thread so it doesn't block the rest of Gatherer.
+	* @see java.lang.Exception
+	* @see java.lang.Process
+	* @see java.lang.Runtime
+	* @see java.lang.System
+	* @see java.util.Vector
+	*/
+		public void run() {
+			// Call an external process using the args.
+			if(commands == null) {
+				apps.remove(this);
+				return;
+			}
+			try {
+				String prog_name = commands[0];
+				String lower_name = prog_name.toLowerCase();
+				if (lower_name.indexOf("mozilla") != -1 || lower_name.indexOf("netscape") != -1) { 
+					DebugStream.println("found mozilla or netscape, trying remote it");
+					// mozilla and netscape, try using a remote command to get things in the same window
+					String [] new_commands = new String[] {prog_name, "-raise", "-remote", "openURL("+url+",new-tab)"};
+					printArray(new_commands);
+
+					Runtime rt = Runtime.getRuntime();
+					process = rt.exec(new_commands);
+					int exitCode = process.waitFor();
+					if (exitCode != 0) { // if Netscape or mozilla was not open
+						DebugStream.println("couldn't do remote, trying original command");
+						printArray(commands);
+						process = rt.exec(commands); // try the original command
+					}
+				} else {
+					// just run what we have been given
+					StringBuffer whole_command = new StringBuffer();
+					for(int i = 0; i < commands.length; i++) {
+						whole_command.append(commands[i]);
+						whole_command.append(" ");
+					}
+					DebugStream.println("Running " + whole_command.toString());
+					Runtime rt = Runtime.getRuntime();
+					process = rt.exec(commands);
+					process.waitFor();
+				}
+			}
+			
+			catch (Exception exception) {
+				DebugStream.printStackTrace(exception);
+			}
+			// Remove ourself from Gatherer list of threads.
+			apps.remove(this);
+			// Call exit if we were the last outstanding child process thread.
+			if (apps.size() == 0 && exit == true) {
+				System.exit(exit_status);
+			}
+		}
+		public void printArray(String [] array) {
+			for(int i = 0; i < array.length; i++) {
+				DebugStream.print(array[i]+" ");
+				System.err.println(array[i]+" ");
+			}
+		}
+		public void stopBrowserApplication() {
+			if(process != null) {
+				process.destroy();
+			}
+		}
+	}
+
+
+	private class ImageMagickTest
+	{
+		public boolean found()
+		{
+			try {
+				String[] command = new String[2];
+				command[0] = (Utility.isWindows() ? "identify.exe" : "identify");
+				command[1] = "-version";
+				Process image_magick_process = Runtime.getRuntime().exec(command);
+				image_magick_process.waitFor();
+
+				//new way of detection of ImageMagick
+				InputStreamReader isr = new InputStreamReader(image_magick_process.getInputStream());
+
+				BufferedReader br = new BufferedReader(isr);
+				// Capture the standard output stream and seach for two particular occurances: Version and ImageMagick.
+
+				String line = br.readLine();
+				if (line == null) {
+					return false;
+				}
+				String lc_line = line.toLowerCase();
+				if (lc_line.indexOf("version") != -1 || lc_line.indexOf("imagemagick") != -1) {
+					return true;
+				} else {
+					return false;
+				}
+
+				//return (image_magick_process.exitValue() == 0);
+			}
+			catch (IOException exception) {
+				return false;
+			}
+			catch (InterruptedException exception) {
+				return false;
+			}
+		}
+	}
+
+
+	private class PerlTest
+	{
+		private String[] command = new String[2];
+
+		public PerlTest()
+		{
+			command[0] = (Utility.isWindows() ? Utility.PERL_EXECUTABLE_WINDOWS : Utility.PERL_EXECUTABLE_UNIX);
+			command[1] = "-version";
+		}
+
+		public boolean found()
+		{
+			try {
+				Process perl_process = Runtime.getRuntime().exec(command);
+				perl_process.waitFor();
+				return (perl_process.exitValue() == 0);
+			}
+			catch (Exception exception) {
+				return false;
+			}
+		}
+
+		public String toString() {
+			return command[0];
+		}
 	}
 	
-	public String getID() { 
-	    return ID; 
-	}
-
-	/** We start the child process inside a new thread so it doesn't block the rest of Gatherer.
-	 * @see java.lang.Exception
-	 * @see java.lang.Process
-	 * @see java.lang.Runtime
-	 * @see java.lang.System
-	 * @see java.util.Vector
-	 */
-	public void run() {
-	    // Call an external process using the args.
-	    try {
-		if(commands != null) {
-		    StringBuffer whole_command = new StringBuffer();
-		    for(int i = 0; i < commands.length; i++) {
-			whole_command.append(commands[i]);
-			whole_command.append(" ");
-		    }
-		    DebugStream.println("Running " + whole_command.toString());
-		    Runtime rt = Runtime.getRuntime();
-		    process = rt.exec(commands);
-		    process.waitFor();
-		}
-		else {
-		    DebugStream.println("Running " + command);
-		    Runtime rt = Runtime.getRuntime();
-		    process = rt.exec(command);
-		    process.waitFor();
-		}
-	    }
-	    catch (Exception exception) {
-		DebugStream.printStackTrace(exception);
-	    }
-	    // Remove ourself from Gatherer list of threads.
-	    apps.remove(this);
-	    // Call exit if we were the last outstanding child process thread.
-	    if (apps.size() == 0 && exit == true) {
-		// In my opinion (DB) there is no need to exit here,
-		// the 'run' method ending naturally brings this
-		// thread to an end.  In fact it is potentially
-		// dangerous to exit here, as the main thread in the
-		// Gatherer class may be stopped prematurely.  As it so
-		// happens the point at which the ExternalApplication thread
-		// is asked to stop (Back in the main Gatherer thread) is after
-		// various configuration files have been saved.
-		// 
-		// A similar argument holds for BrowserApplication thread below.
-		System.exit(exit_status);
-	    }
-	}
-	public void stopExternalApplication() {
-	    if(process != null) {
-		process.destroy();
-	    }
-	}
-    }
-    /** This private class contains an instance of an external application running within a JVM shell. It is important that this process sits in its own thread, but its more important that when we exit the Gatherer we don't actually System.exit(0) the Gatherer object until the user has volunteerily ended all of these child processes. Otherwise when we quit the Gatherer any changes the users may have made in external programs will be lost and the child processes are automatically deallocated. */
-    static private class BrowserApplication
-	extends Thread {
-	private Process process = null;
-	/** The initial command string given to this sub-process. */
-	private String command = null;
-	private String url = null;
-	private String[] commands = null;
-
-	public BrowserApplication(String command, String url) {
-	    StringTokenizer st = new StringTokenizer(command);
-	    int num_tokens = st.countTokens();
-	    this.commands = new String [num_tokens];
-	    int i=0;
-	    while (st.hasMoreTokens()) {
-		commands[i] = st.nextToken();
-		i++;
-	    }
-	    //this.commands = commands;
-	    this.url = url;
-	}
-	/** We start the child process inside a new thread so it doesn't block the rest of Gatherer.
-	 * @see java.lang.Exception
-	 * @see java.lang.Process
-	 * @see java.lang.Runtime
-	 * @see java.lang.System
-	 * @see java.util.Vector
-	 */
-	public void run() {
-	    // Call an external process using the args.
-	    if(commands == null) {
-		apps.remove(this);
-		return;
-	    }
-	    try {
-		String prog_name = commands[0];
-		String lower_name = prog_name.toLowerCase();
-		if (lower_name.indexOf("mozilla") != -1 || lower_name.indexOf("netscape") != -1) { 
-		    DebugStream.println("found mozilla or netscape, trying remote it");
-		    // mozilla and netscape, try using a remote command to get things in the same window
-		    String [] new_commands = new String[] {prog_name, "-raise", "-remote", "openURL("+url+",new-tab)"};
-		    printArray(new_commands);
-
-		    Runtime rt = Runtime.getRuntime();
-		    process = rt.exec(new_commands);
-		    int exitCode = process.waitFor();
-		    if (exitCode != 0) { // if Netscape or mozilla was not open
-			DebugStream.println("couldn't do remote, trying original command");
-			printArray(commands);
-			process = rt.exec(commands); // try the original command
-		    }
-		} else {
-		    // just run what we have been given
-		    StringBuffer whole_command = new StringBuffer();
-		    for(int i = 0; i < commands.length; i++) {
-			whole_command.append(commands[i]);
-			whole_command.append(" ");
-		    }
-		    DebugStream.println("Running " + whole_command.toString());
-		    Runtime rt = Runtime.getRuntime();
-		    process = rt.exec(commands);
-		    process.waitFor();
-		}
-	    }
-	    
-	    catch (Exception exception) {
-		DebugStream.printStackTrace(exception);
-	    }
-	    // Remove ourself from Gatherer list of threads.
-	    apps.remove(this);
-	    // Call exit if we were the last outstanding child process thread.
-	    if (apps.size() == 0 && exit == true) {
-		System.exit(exit_status);
-	    }
-	}
-	public void printArray(String [] array) {
-	    for(int i = 0; i < array.length; i++) {
-		DebugStream.print(array[i]+" ");
-		System.err.println(array[i]+" ");
-	    }
-	}
-	public void stopBrowserApplication() {
-	    if(process != null) {
-		process.destroy();
-	    }
-	}
-    }
-
-
-    private class ImageMagickTest
-    {
-	public boolean found()
-	{
-	    try {
-		String[] command = new String[2];
-		command[0] = (Utility.isWindows() ? "identify.exe" : "identify");
-		command[1] = "-version";
-		Process image_magick_process = Runtime.getRuntime().exec(command);
-		image_magick_process.waitFor();
-
-		//new way of detection of ImageMagick
-		InputStreamReader isr = new InputStreamReader(image_magick_process.getInputStream());
-
-	        BufferedReader br = new BufferedReader(isr);
-	        // Capture the standard output stream and seach for two particular occurances: Version and ImageMagick.
-
-	        String line = br.readLine();
-		if (line == null) {
-		    return false;
-		}
-	        String lc_line = line.toLowerCase();
-		if (lc_line.indexOf("version") != -1 || lc_line.indexOf("imagemagick") != -1) {
-			return true;
-		} else {
-		        return false;
-		}
-
-		//return (image_magick_process.exitValue() == 0);
-	    }
-	    catch (IOException exception) {
-		return false;
-	    }
-	    catch (InterruptedException exception) {
-		return false;
-	    }
-	}
-    }
-
-
-    private class PerlTest
-    {
-	private String[] command = new String[2];
-
-	public PerlTest()
-	{
-	    command[0] = (Utility.isWindows() ? Utility.PERL_EXECUTABLE_WINDOWS : Utility.PERL_EXECUTABLE_UNIX);
-	    command[1] = "-version";
-	}
-
-	public boolean found()
-	{
-	    try {
-		Process perl_process = Runtime.getRuntime().exec(command);
-		perl_process.waitFor();
-		return (perl_process.exitValue() == 0);
-	    }
-	    catch (Exception exception) {
-		return false;
-	    }
-	}
-
-	public String toString() {
-	    return command[0];
-	}
-    }
+	public class GS3ServerThread extends Thread
+	{
+		String _gsdl_path = "";
+		
+		public GS3ServerThread(String gsdl_path)
+		{
+			_gsdl_path = gsdl_path;
+		}
+		
+		public void run()
+		{
+			try
+			{
+				String shellCommand = null;
+				if (Utility.isWindows())
+				{
+					shellCommand = "cmd /C";
+				}
+				else
+				{
+					shellCommand = "bash -c";
+				}
+				
+				Process p = Runtime.getRuntime().exec(shellCommand + " \"cd " + _gsdl_path + File.separator + ".. && ant start\"");
+			}
+			catch(Exception ex)
+			{
+				ex.printStackTrace();
+			}
+		}
+	}
 }
